# implementace cyklického seznamu
class clist(list):

    # předefinování metody pro správu výřezu clist[idx]
    def __getitem__(self, idx):
        
        # aktuální počet prvků seznamu
        lself = len(self)
        
        # rozlišení podle vstupního typu výřezu
        # (velmi podivným, ale standardizovaným způsobem zásahu na typ…)
        match idx:
            # výřez seznamu je buď celé číslo..
            case int():
                return super().__getitem__(idx % lself)
            # ..nebo objekt typu 'slice(start, stop, step)'
            # (závorky v ifech jsou nadbytečné, ale líp se to s nimi čte)
            case slice():
                start = None if (idx.start == None) else (idx.start % lself)
                stop = None if (idx.stop == None) else (idx.stop % lself)
                return super().__getitem__(slice(start, stop, idx.step))
            # neznámé hodnoty necháme ke zpracování originálu
            case _:
                return super().__getitem__(idx)


# zavedení
#xs = clist([1, 2, 3])
xs = clist(range(1, 4))

# testy
print(xs)       # [1, 2, 3]

print(xs[2])    # 3
print(xs[-4])   # 3

print(xs[3])    # 1
print(xs[-3])   # 1

print(xs[:])    # [1, 2, 3]

print(xs[2:])   # [3]
print(xs[-4:])  # [3]
print(xs[4:])   # [2, 3]
print(xs[-5:])  # [2, 3]

print(xs[:2])   # [1, 2]
print(xs[:5])   # [1, 2]

print(xs[-6:-7])    # [1, 2]

print(xs[::2])      # [1, 3]
print(xs[3:5:2])    # [1]
print(xs[3:6:2])    # []
